const Cc = Components.classes;
const Ci = Components.interfaces;

var isHelpOpen = false;
var listbox;
var prefs;

function start() {
  prefs = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService);
  prefs = prefs.getBranch(null);

  listbox = document.getElementById("listbox");
  
  var items = [];
  var itemsIMP = [];

  items = prefs.getCharPref("extension.foobar.items").split(",");
  itemsIMP = prefs.getCharPref("extension.foobar.itemsIMP").split(",");

  for (var i = 0; i < itemsIMP.length; i++) {
    var item = itemsIMP[i];
    if (item != "")
      addDOMItem(item, true);
  }
  for (var i = 0; i < items.length; i++) {
    var item = items[i];
    if (item != "")
      addDOMItem(item, false);
  }
}

function help() {
  var helpbox = document.getElementById("helpbox");
  if (isHelpOpen) {
    helpbox.style.visibility = "collapse";
    listbox.style.visibility = "visible";
  } else {
    helpbox.style.visibility = "visible";
    listbox.style.visibility = "collapse";
  }
  isHelpOpen = !isHelpOpen;
}



function addItem() {
  var label = window.prompt("Label du nouvel item:");
  addDOMItem(label, false);
}

function addDOMItem(label, imp) {
  var item = document.createElement("listitem");
  item.setAttribute("label", label);
  if (imp) {
    item.setAttribute("important", "true");
  }
  listbox.appendChild(item);
}

function delItem() {
  listbox.removeChild(listbox.selectedItem);
}

function starItem() {
  if (listbox.selectedItem.getAttribute("important") == "true") {
    listbox.selectedItem.removeAttribute("important");
  } else {
    listbox.selectedItem.setAttribute("important", true);
  }
}

function saveList() {
  var items = [];
  var itemsIMP = [];
  var DOMItems = listbox.childNodes;
  for (var i = 0; i < DOMItems.length; i++) {
    var item = DOMItems[i];
    if (item.getAttribute("important") == "true") {
      itemsIMP.push(item.getAttribute("label"));
    } else {
      items.push(item.getAttribute("label"));
    }
  }
  prefs.setCharPref("extension.foobar.items", items.join());
  prefs.setCharPref("extension.foobar.itemsIMP", itemsIMP.join());
}

window.addEventListener("load", start, true);
